## mingw-w64-python-lief-0.17.4-1.src.tar.zst

=== doc/requirements.txt ===
requests==2.32.5
sphinx==9.1.99
Pygments==2.19.2
breathe==4.36.0
git+https://github.com/executablebooks/sphinx-tabs.git@d613cb7b6bff083227e35e9b3a4c56b24f6c6ad4

=== PKGBUILD ===
# Maintainer: Marcelo Duarte https://github.com/marcelotduarte

_realname=lief
pkgbase=mingw-w64-python-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-python-${_realname}
pkgdesc="LIEF - Library to Instrument Executable Formats (mingw-w64)"
pkgver=0.17.4
pkgrel=1
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/lief-project/LIEF/"
msys2_repository_url='https://github.com/lief-project/LIEF'
msys2_references=(
  "cpe: cpe:/a:lief-project:lief"
  'purl: pkg:pypi/lief'
)
license=('spdx:Apache-2.0')
depends=(
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-mbedtls"
  "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-tl-expected"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-ccache"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-nanobind"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-cattrs"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-python-packaging"
  "${MINGW_PACKAGE_PREFIX}-python-pathspec"
  "${MINGW_PACKAGE_PREFIX}-python-pydantic"
  "${MINGW_PACKAGE_PREFIX}-python-pydantic-core"
  "${MINGW_PACKAGE_PREFIX}-python-pyproject-metadata"
  "${MINGW_PACKAGE_PREFIX}-python-rich"
  "${MINGW_PACKAGE_PREFIX}-python-scikit-build-core"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-tomli"
)
options=('!strip')
source=(
  https://github.com/lief-project/LIEF/archive/${pkgver}/${_realname}-${pkgver}.tar.gz
  001-fix-setup.patch
)
sha256sums=('cc1c8c563faaddf497d1a2d8f2712257f15e680e6a5ef4ea1e29ba8e19fb6248'
            '8cab3f9aa2d010232b8d782bc09be0136752bd5f41b5d8a4dae976ac4b47d9a2')

prepare() {
  pushd "LIEF-${pkgver}"
  patch -p0 -i ../001-fix-setup.patch
  popd

  rm -rf build-${MSYSTEM} | true
  cp -r "LIEF-${pkgver}" "build-${MSYSTEM}"
}

build() {
  cd build-${MSYSTEM}/api/python

  mv -n config-default.toml config-default.toml.bak
  cat << EOF > config-default.toml
[lief.build]
type          = "Release"
cache         = true
ninja         = true
parallel-jobs = 0
extra-cmake-opt = [
  "-DBUILD_SHARED_LIBS=OFF",
  "-DCMAKE_SKIP_RPATH=ON",
  "-DLIEF_EXAMPLES=OFF",
  "-DLIEF_EXTERNAL_SPDLOG=ON",
  "-DLIEF_OPT_EXTERNAL_EXPECTED=ON",
  "-DLIEF_OPT_MBEDTLS_EXTERNAL=ON",
  "-DLIEF_OPT_NANOBIND_EXTERNAL=ON",
  "-DLIEF_OPT_NLOHMANN_JSON_EXTERNAL=ON",
  "-DLIEF_PYTHON_API=ON",
]

[lief.formats]
elf     = false
pe      = true
macho   = false
android = false
art     = false
vdex    = false
oat     = false
dex     = false

[lief.features]
json    = true
frozen  = true

[lief.logging]
enabled = true
debug   = false
EOF

  ${MINGW_PREFIX}/bin/python -m build --wheel --skip-dependency-check --no-isolation
}

package() {
  cd build-${MSYSTEM}
  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" api/python/dist/*.whl
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/LICENSE"
}
